from crystals import prism

##PODLINGS
class facetOne(prism.Facet):
    
    def __init__(self):
        self.name = 'facetOne'
        self.height = '80%'
        self.width = 200
        self.top = 30
        self.left = 10

    def render(self):
        return """
        <b>facet One</b><br>
        The idea of this pattern/framework is to create pages (prisms)
        out of varous common components (facets).<br><br>
        <b>TODO:</b><br>
        create the concept of 'observers' and 'broadcasters'. facets can 
        register their wish to observe (wait for a particulat notification)
        or notify (create a broadcast). in this way all facets can 
        communicate and update each other.<br><br>
        Once this is done 'request' can be wrapped in a special facet which
        can broadcast to any facet that wants to know, of GET, POST, JS events etc.
    """
    
class facetTwo(prism.Facet):
    
    def __init__(self):
        self.name = 'facetTwo'
        self.height = '200'
        self.width = 100
        self.top = 30
        self.left = 220

    def render(self):
        return "<i>facet Two</i>"
 


class facetThree(prism.Facet):
    
    def __init__(self):
        self.name = 'facetThree'
        self.height = '50'
        self.width = 100
        self.top = 250
        self.left = 220


#    def render(self):
#        return "<br>facet three"


##PODS
class prismOne(prism.Prism):
    name = 'prismOne'
    url = 'prismOne'
    facets = [facetTwo, facetOne]
    
class prismTwo(prism.Prism):
    name = 'prismTwo'
    url = 'prismTwo'
    facets = [facetOne, facetThree]

class allFacets(prism.Prism):
    name = 'all facets'
    url = 'allFacets'
    facets = [facetOne, facetTwo, facetThree]

